/*---------------------------------------------------------------------------*/
//       Author : hiyohiyo
//         Mail : hiyohiyo@crystalmark.info
//          Web : http://crystalmark.info/
//      License : The modified BSD license
//
//                                Copyright 2002- hiyohiyo All rights reserved.
/*---------------------------------------------------------------------------*/

#ifndef __CPU_INFO_ID_H__
#define __CPU_INFO_ID_H__

////////////
// URL
//////////////////////////////////////////

#define URL_JAPANESE	"http://crystalmark.info/"
#define URL_ENGLISH		"http://crystalmark.info/?lang=en"

////////////
// Version Information
//////////////////////////////////////////

#define		CRYSTAL_CPUID_VERSION		"2.5.0"			// Max 16
#define		CRYSTAL_CPUID_DATE			"2003/12/24"	// Max 10
#define		CRYSTAL_CPUID_AUTHOR		"hiyohiyo"		// Max 24

// If you modify CrystalCPUID. Please write your name this section.
//#define		CRYSTAL_CPUID_MODIFIED		"YOUR NAME"		// Max 24
#define		CRYSTAL_CPUID_MODIFIED		""				// Max 24

////////////
// CpuInfo.dll
//////////////////////////////////////////

#define		CPU_INFO_VERSION			"38"			// Max 4
#define		CPU_INFO_DATE				"2003/12/04"	// Max 10
#define		CPU_INFO_AUTHOR				"hiyohiyo"		// Max 24

////////////
// CpuInfo.dll Status
/////////////////////////////////////////

#define		SI_VERSION					0x0001
#define		SI_DATE						0x0002
#define		SI_AUTHOR					0x0003

#define		SI_STATUS					0x0010
#define		SI_MEASURE_TIME				0x0020

////////////
// CPU
//////////////////////////////////////////

#define		CPU_BASE					0x1000

// String //
#define		CPU_NAME_SYS_INFO			0x1001	// SysInfo.dll Set CPU Name 
#define		CPU_FSB_MODE				0x1002	// ""=SDR "DDR" "QDR"
#define		CPU_VENDOR_STRING			0x1003	// OriginalVendorString
#define		CPU_VENDOR_NAME				0x1004	// Vendor Name
#define		CPU_NAME_STRING				0x1005	// CPUID EAX=0x8000:0003-0005
#define		CPU_PLATFORM_NAME			0x1006	// Soket/Slot Info
#define		CPU_TYPE_NAME				0x1007	// OEM Multi OverDrive
#define		CPU_FMS						0x1008	// Family Model Stepping
#define		CPU_CACHE_SPEED_STR			0x1009	// L2 Cache Speed info
#define		CPU_NAME					0x100A	// CPU Name
#define		CPU_CODE_NAME				0x100B	// Code Name
#define		CPU_FULL_NAME				0x100C	// Vendor Name + CPU Name
#define		CPU_PROCESS_RULE			0x100D	// Process Rule
#define		CPU_PROCESSOR_SERIAL		0x100E	// Intel Processor Serial Number

// dobule //
#define		CPU_CLOCK					0x1020
#define		CPU_SYSTEM_CLOCK			0x1021
#define		CPU_SYSTEM_BUS				0x1022
#define		CPU_MULTIPLIER				0x1023
#define		CPU_CLOCK_ORI				0x1024
#define		CPU_SYSTEM_CLOCK_ORI		0x1025
#define		CPU_SYSTEM_BUS_ORI			0x1026
#define		CPU_CACHE_SPEED				0x1027	// L2 Cache Speed info
#define		CPU_OVER_CLOCK				0x1028
#define		CPU_MULTIPLIER_ORI			0x1029
#define		CPU_CLOCK_UPDATE			0x102A
#define		CPU_MULTIPLIER_UPDATE		0x102B

// integer //
#define		CPU_NUMBER					0x1030
#define		CPU_VIRTUAL_NUMBER			0x1030
#define		CPU_FAMILY					0x1031
#define		CPU_MODEL					0x1032
#define		CPU_STEPPING				0x1033
#define		CPU_FAMILY_EX				0x1034	// for Intel
#define		CPU_MODEL_EX				0x1035	// for Intel
#define		CPU_BRAND_ID				0x1036	// for Intel
#define		CPU_FEATURE					0x1037	// CPUID EAX=0x00000001  EDX
#define		CPU_FEATURE_EX				0x1038	// CPUID EAX=0x80000001  EDX			
#define		CPU_CACHE_L1I				0x1039	
#define		CPU_CACHE_L1T				0x103A	// NetBurst micro-ops
#define		CPU_CACHE_L1D				0x103B
#define		CPU_CACHE_L2				0x103C
#define		CPU_CACHE_L3				0x103D
#define		CPU_HYPER_THREAD_NUM		0x103E
#define		CPU_TYPE					0x103F	// OEM Multi OverDrive
#define		CPU_RDMSR_EAX				0x1040
#define		CPU_RDMSR_EAX_1				0x1040
#define		CPU_RDMSR_EAX_2				0x1041
#define		CPU_FSB_MULTIPLIER			0x1042
#define		CPU_CACHE_L1U				0x1043	
#define		CPU_VERSION					0x1044	// CPUID EAX=0x00000001  EAX
#define		CPU_VERSION_EX				0x1045	// CPUID EAX=0x80000001  EAX
#define		CPU_FLAG_BRAND				0x1046
#define		CPU_APIC					0x1047
#define		CPU_RDMSR_EDX_1				0x1048
#define		CPU_RDMSR_EDX_2				0x1049
#define		CPU_PHYSICAL_NUMBER			0x104A
#define		CPU_FEATURE_ECX				0x104B	// CPUID EAX=0x00000001  ECX
#define		CPU_VENDOR_ID				0x104C

// flag //
#define		CPU_FLAG_MMX				0x1050
#define		CPU_FLAG_MMX_EX				0x1051
#define		CPU_FLAG_SSE				0x1052
#define		CPU_FLAG_SSE2				0x1053
#define		CPU_FLAG_3DNOW				0x1054
#define		CPU_FLAG_3DNOW_EX			0x1055
#define		CPU_FLAG_HYPER_THREAD		0x1056
#define		CPU_FLAG_HTT				0x1056
#define		CPU_FLAG_AA64				0x1057
#define		CPU_FLAG_IA64				0x1058
#define		CPU_FLAG_SSE3				0x1059
#define		CPU_FLAG_PROCESSOR_SERIAL	0x105A
#define		CPU_FLAG_SPEED_STEP			0x105B
#define		CPU_FLAG_POWER_NOW			0x105C
#define		CPU_FLAG_LONG_HAUL			0x105D
#define		CPU_FLAG_LONG_RUN			0x105E

// for Transmeta // 
#define		CPU_TM_NAME_STRING			0x1060
#define		CPU_TM_CLOCK				0x1061
#define		CPU_TM_NOMINAL_CLOCK		0x1062
#define		CPU_TM_CURRENT_VOLTAGE		0x1063
#define		CPU_TM_CURRENT_PERFORMANCE	0x1064
#define		CPU_TM_CURRENT_GATE_DELAY	0x1065
#define		CPU_TM_HARDWARE_VERSION		0x1066
#define		CPU_TM_SOFTWARE_VERSION		0x1067
#define		CPU_TM_UPDATE				0x1068

// for Cache
#define		CPU_CACHE_L1ITU_WAYS		0x1080
#define		CPU_CACHE_L1ITU_LINES		0x1081
#define		CPU_CACHE_L1D_WAYS			0x1082
#define		CPU_CACHE_L1D_LINES			0x1083
#define		CPU_CACHE_L2_WAYS			0x1084
#define		CPU_CACHE_L2_LINES			0x1085
#define		CPU_CACHE_L3_WAYS			0x1086
#define		CPU_CACHE_L3_LINES			0x1087

// Update CPU Information
#define		CPU_UPDATE_BASE				0x1100

// Tuning
#define		LH_BASE						0x1200
#define		LH_GET_CURRENT_STATUS		0x1200
#define		LH_GET_TYPE					0x1201
#define		LH_GET_TABLE_TYPE			0x1202

#define		LH_GET_CURRENT_FID			0x1211
#define		LH_GET_STARTUP_FID			0x1212
#define		LH_GET_MAX_FID				0x1213
#define		LH_GET_CURRENT_MULTIPLIER	0x1214
#define		LH_GET_STARTUP_MULTIPLIER	0x1215
#define		LH_GET_MAX_MULTIPLIER		0x1216
#define		LH_SET_FID					0x1217

#define		LH_GET_CURRENT_VID			0x1221
#define		LH_GET_STARTUP_VID			0x1222
#define		LH_GET_MAX_VID				0x1223
#define		LH_GET_CURRENT_VOLTAGE		0x1224
#define		LH_GET_STARTUP_VOLTAGE		0x1225
#define		LH_GET_MAX_VOLTAGE			0x1226
#define		LH_SET_VID					0x1227

////////////
// CPU Vendor ID
//////////////////////////////////////////

#define		INTEL						1
#define		AMD							2
#define		TMx86						3
#define		CYRIX						4
#define		IDT							5
#define		SIS							6
#define		UMC							7
#define		RISE						8
#define		NEXGEN						9
#define		COMPAQ					   10
#define		NSC						   11

////////////
// System Bus & Multipler Table
//////////////////////////////////////////

#define		GENERAL					    0
#define		P6						    1
#define		COPPERMINE				    3
#define		TUALATIN				    4
#define		WILLAMETTE					5
#define		NORTHWOOD					6
#define		BANIAS						7
#define		K6						   10
#define		ATHLON					   11
#define		MOBILE_ATHLON			   12
#define		ATHLON_64				   13
#define		MOBILE_ATHLON_64		   14

#define		CYRIX3					   20 // CYRIX3 = SAMUEL
#define		SAMUEL					   20
#define		SAMUEL2					   21
#define		EZRA					   22
#define		EZRA_T					   23
#define		NEHEMIAH				   24

////////////
// LongHole (VIA C3 Multiplier Change)
//////////////////////////////////////////
#define		LONG_HAUL_LEVEL_1			1 // Samuel  & Samuel2 & Ezra
#define		LONG_HAUL_LEVEL_2			2 // Ezra-T & VIA C3 Nehemiah

////////////
// Love Hammer (AMD K7/K8 Multiplier Change)
//////////////////////////////////////////
#define		LOVE_HAMMER_K7				7
#define		LOVE_HAMMER_K8				8

////////////
// Language
//////////////////////////////////////////

#define		JAPANESE				0x0001
#define		ENGLISH					0x0002

#endif // __CPU_INFO_ID_H__
